# This file was auto-generated by Fern from our API Definition.

import enum
import typing

T_Result = typing.TypeVar("T_Result")


class FieldCreateType(str, enum.Enum):
    """
    Choose these appropriate field type for your collection data
    """

    PLAIN_TEXT = "PlainText"
    RICH_TEXT = "RichText"
    IMAGE = "Image"
    MULTI_IMAGE = "MultiImage"
    VIDEO = "Video"
    LINK = "Link"
    EMAIL = "Email"
    PHONE = "Phone"
    NUMBER = "Number"
    DATE_TIME = "DateTime"
    BOOLEAN = "Boolean"
    COLOR = "Color"
    FILE = "File"

    def visit(
        self,
        plain_text: typing.Callable[[], T_Result],
        rich_text: typing.Callable[[], T_Result],
        image: typing.Callable[[], T_Result],
        multi_image: typing.Callable[[], T_Result],
        video: typing.Callable[[], T_Result],
        link: typing.Callable[[], T_Result],
        email: typing.Callable[[], T_Result],
        phone: typing.Callable[[], T_Result],
        number: typing.Callable[[], T_Result],
        date_time: typing.Callable[[], T_Result],
        boolean: typing.Callable[[], T_Result],
        color: typing.Callable[[], T_Result],
        file: typing.Callable[[], T_Result],
    ) -> T_Result:
        if self is FieldCreateType.PLAIN_TEXT:
            return plain_text()
        if self is FieldCreateType.RICH_TEXT:
            return rich_text()
        if self is FieldCreateType.IMAGE:
            return image()
        if self is FieldCreateType.MULTI_IMAGE:
            return multi_image()
        if self is FieldCreateType.VIDEO:
            return video()
        if self is FieldCreateType.LINK:
            return link()
        if self is FieldCreateType.EMAIL:
            return email()
        if self is FieldCreateType.PHONE:
            return phone()
        if self is FieldCreateType.NUMBER:
            return number()
        if self is FieldCreateType.DATE_TIME:
            return date_time()
        if self is FieldCreateType.BOOLEAN:
            return boolean()
        if self is FieldCreateType.COLOR:
            return color()
        if self is FieldCreateType.FILE:
            return file()
