# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

from ..core.datetime_utils import serialize_datetime
from .sku_field_data import SkuFieldData

try:
    import pydantic.v1 as pydantic  # type: ignore
except ImportError:
    import pydantic  # type: ignore


class Sku(pydantic.BaseModel):
    """
    The SKU object
    """

    id: typing.Optional[str] = pydantic.Field(default=None, description="Unique identifier for the Product")
    last_published: typing.Optional[dt.datetime] = pydantic.Field(
        alias="lastPublished", default=None, description="The date the Product was last published"
    )
    last_updated: typing.Optional[dt.datetime] = pydantic.Field(
        alias="lastUpdated", default=None, description="The date the Product was last updated"
    )
    created_on: typing.Optional[dt.datetime] = pydantic.Field(
        alias="createdOn", default=None, description="The date the Product was created"
    )
    field_data: typing.Optional[SkuFieldData] = pydantic.Field(
        alias="fieldData", default=None, description="Standard and Custom fields for a SKU"
    )

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        smart_union = True
        allow_population_by_field_name = True
        json_encoders = {dt.datetime: serialize_datetime}
